import net.sf.flashlib.util.Delegate;

import net.sf.emff.EMFF;
import net.sf.emff.UpdateUtil;
import net.sf.emff.configuration.ConfigurationFlashVars;



/**
 * The "debug" skin.
 * 
 * @version  0.0.2
 * @author   Marc Reichelt
 */
class Skin {
	
	/**
	 * Creates the skin.
	 */
	public static function main() : Void {
		
		if (UpdateUtil.getInstance().updateNeeded()) {
			return;
		}
		
		// create debug text field
		_root.createTextField("debug", _root.getNextHighestDepth(), 10, 10, 780, 350);
		var debug : TextField = _root.debug;
		debug.background = true;
		debug.backgroundColor = 0xffffff;
		debug.border = true;
		
		// read configuration and create new player
		var emff : EMFF = new EMFF( new ConfigurationFlashVars() );
		
		// create buttons
		var previousMC : MovieClip = _root.createEmptyMovieClip("previousMC", _root.getNextHighestDepth());
		previousMC._x = 10;
		previousMC._y = 370;
		previousMC.createTextField("tf", previousMC.getNextHighestDepth(), 0, 0, 0, 0);
		previousMC.tf.autoSize = true;
		previousMC.tf.border = true;
		previousMC.tf.text = "previous";
		previousMC.onRelease = Delegate.create(emff, emff.previous);
		
		var stopMC : MovieClip = _root.createEmptyMovieClip("stopMC", _root.getNextHighestDepth());
		stopMC._x = Math.round(previousMC._x + previousMC._width + 7);
		stopMC._y = 370;
		stopMC.createTextField("tf", stopMC.getNextHighestDepth(), 0, 0, 0, 0);
		stopMC.tf.autoSize = true;
		stopMC.tf.border = true;
		stopMC.tf.text = "stop";
		stopMC.onRelease = Delegate.create(emff, emff.stop);
		
		var pauseMC : MovieClip = _root.createEmptyMovieClip("pauseMC", _root.getNextHighestDepth());
		pauseMC._x = Math.round(stopMC._x + stopMC._width + 7);
		pauseMC._y = 370;
		pauseMC.createTextField("tf", pauseMC.getNextHighestDepth(), 0, 0, 0, 0);
		pauseMC.tf.autoSize = true;
		pauseMC.tf.border = true;
		pauseMC.tf.text = "pause";
		pauseMC.onRelease = Delegate.create(emff, emff.pause);
		
		var playMC : MovieClip = _root.createEmptyMovieClip("playMC", _root.getNextHighestDepth());
		playMC._x = Math.round(pauseMC._x + pauseMC._width + 7);
		playMC._y = 370;
		playMC.createTextField("tf", playMC.getNextHighestDepth(), 0, 0, 0, 0);
		playMC.tf.autoSize = true;
		playMC.tf.border = true;
		playMC.tf.text = "play";
		playMC.onRelease = Delegate.create(emff, emff.play);
		
		var nextMC : MovieClip = _root.createEmptyMovieClip("nextMC", _root.getNextHighestDepth());
		nextMC._x = Math.round(playMC._x + playMC._width + 7);
		nextMC._y = 370;
		nextMC.createTextField("tf", nextMC.getNextHighestDepth(), 0, 0, 0, 0);
		nextMC.tf.autoSize = true;
		nextMC.tf.border = true;
		nextMC.tf.text = "next";
		nextMC.onRelease = Delegate.create(emff, emff.next);
		
		var volMC : MovieClip = _root.createEmptyMovieClip("volMC", _root.getNextHighestDepth());
		volMC._x = Math.round(nextMC._x + nextMC._width + 7);
		volMC._y = 370;
		volMC.createTextField("tf", volMC.getNextHighestDepth(), 0, 0, 0, 0);
		volMC.tf.autoSize = true;
		volMC.tf.border = true;
		volMC.tf.text = "setVolume(10)";
		volMC.onRelease = function() : Void { emff.setVolume(10); };
		
		
		
		_root.onEnterFrame = function () : Void {
			debug.text = "getStatus: " + emff.getStatus() + "\n"
				+ "getActiveTrack(): " + emff.getActiveTrack().toString() + "\n"
				+ "getPlaylist(): " + emff.getPlaylist().toString() + "\n"
				+ "getLoadingProgress(): " + emff.getLoadingProgress() + "\n"
				+ "getPlayingProgress(): " + emff.getPlayingProgress() + "\n"
				+ "getBalance(): " + emff.getBalance() + "\n"
				+ "getVolume(): " + emff.getVolume() + "\n";
		}
		
	}
	
}
