import net.sf.flashlib.util.Delegate;

import net.sf.emff.EMFF;
import net.sf.emff.UpdateUtil;

import net.sf.emff.configuration.ConfigurationFlashVars;



/**
 * The "position_blue" skin.
 * 
 * @version  0.0.1
 * @author   René Schindler
 */
class Skin {
	
	private static var skin : Skin = null;
	
	private var emff : EMFF = null;
	
	private var previousMC : MovieClip = null;
	private var playMC : MovieClip = null;
	private var pauseMC : MovieClip = null;
	private var stopMC : MovieClip = null;
	private var nextMC : MovieClip = null;
	private var playprogressMC : MovieClip = null;
	private var volumeMC : MovieClip = null;
	private var textField : TextField = null;
	
	private var draggingPosition : Boolean = false;
	private var draggingVolume : Boolean = false;
	
	
	/**
	 * Main method that simply creates a new skin.
	 */
	public static function main() : Void {
		
		if (UpdateUtil.getInstance().updateNeeded()) {
			return;
		}
		
		skin = new Skin();
	}
	
	/**
	 * Initialization of this skin.
	 */
	private function Skin() {
		// read configuration and create new player
		emff = new EMFF( new ConfigurationFlashVars() );
		
		// save
		previousMC = _root.previousMC;
		playMC = _root.playMC;
		pauseMC = _root.pauseMC;
		stopMC = _root.stopMC;
		nextMC = _root.nextMC;
		playprogressMC = _root.playprogressMC;
		volumeMC = _root.volumeMC;
		
		// create text field
		_root.createTextField("textField", _root.getNextHighestDepth(), 10, 2, 39, 15);
		textField = _root.textField;
		textField.selectable = false;
		
		var textFormat : TextFormat = new TextFormat();
		textFormat.color = 0x000000;
		textFormat.font = "emffFont";
		textFormat.size = 8;
		textFormat.align = "right";
		textField.embedFonts = true;
		textField.setNewTextFormat(textFormat);
		
		var emff : EMFF = this.emff;
		var textField : TextField = this.textField;
		var previousMC : MovieClip = previousMC;
		var playMC : MovieClip = playMC;
		var pauseMC : MovieClip = pauseMC;
		var stopMC : MovieClip = stopMC;
		var nextMC : MovieClip = nextMC;
		
		// set actions
		previousMC.onRelease = function() {
			previousMC.gotoAndPlay("_up");
			emff.previous();
		};
		playMC.onRelease = function() {
			playMC.gotoAndPlay("_up");
			emff.play();
		};
		pauseMC.onRelease = function() {
			pauseMC.gotoAndPlay("_up");
			emff.pause();
		};
		stopMC.onRelease = function() {
			stopMC.gotoAndPlay("_up");
			emff.stop();
		};
		nextMC.onRelease = function() {
			nextMC.gotoAndPlay("_up");
			emff.next();
		};
		
		// init width of progress bars and draggers
		volumeMC._x = 59 + Math.round(emff.getVolume() / 100 * 20);
		playprogressMC._x = 10;
		playprogressMC._visible = false;
		
		playprogressMC.onPress = Delegate.create(this, pressPlayprogressMC);
		playprogressMC.onRelease = Delegate.create(this, releasePlayprogressMC);
		playprogressMC.onReleaseOutside = playprogressMC.onRelease;
		volumeMC.onPress = Delegate.create(this, pressVolumeMC);
		volumeMC.onRelease = Delegate.create(this, releaseVolumeMC);
		
		_root.onEnterFrame = Delegate.create(this, enterFrame);
	}
	
	
	/**
	 * 
	 */
	private function pressPlayprogressMC() : Void {
		draggingPosition = true;
		emff.pause();
		playprogressMC.startDrag(false, 10, 21, 79, 21);
	}
	
	/**
	 * 
	 */
	private function releasePlayprogressMC() : Void {
		playprogressMC.gotoAndStop("_up");
		
		draggingPosition = false;
		playprogressMC.stopDrag();
		var selected : Number = (playprogressMC._x - 10) / 69;
		if (selected > emff.getLoadingProgress()) {
			// we can not select more than what is loaded yet
			selected = emff.getLoadingProgress();
		}
		emff.setRelativePosition(selected);
		emff.play();
	}
	
	/**
	 * 
	 */
	private function pressVolumeMC() : Void {
		draggingVolume = true;
		volumeMC.startDrag(false, 59, 11, 79, 11);
	}
	
	/**
	 * 
	 */
	private function releaseVolumeMC() : Void {
		volumeMC.gotoAndStop("_up");
		
		draggingVolume = false;
		volumeMC.stopDrag();
	}
	
	/**
	 * Method that is activated every frame and will refresh the visualisation.
	 */
	private function enterFrame() : Void {
		if (emff.getStatus() == EMFF.STOPPED) {
			playprogressMC._visible = false;
		} else {
			playprogressMC._visible = true;
		}
		
		if (!draggingPosition) {
			playprogressMC._x = Math.round(10 + emff.getPlayingProgress() * 69);
		}
		
		if (draggingVolume) {
			emff.setVolume(Math.round((volumeMC._x - 59) / 20 * 100));
		}
		
		
		
		var playedSeconds : Number = Math.round(emff.getPosition() / 1000);
		var minutes : Number = Math.round(Math.floor(playedSeconds / 60));
		var seconds : Number = playedSeconds - minutes * 60;
		
		textField.text = String(minutes + ":" + ((seconds < 10) ? "0" : "") + seconds);
	}
	
}
