import net.sf.emff.configuration.Configuration;



/**
 * Configuration class for the FlashVars method.
 * 
 * @version  0.0.5
 * @author   Marc Reichelt
 */
class net.sf.emff.configuration.ConfigurationFlashVars extends Configuration {
	
	/**
	 * Loads configuration with the FlashVars method and saves it.
	 */
	public function ConfigurationFlashVars() {
		
		// load configuration - contents by the FlashVars method are placed in the _root container
		
		if (_root.playlist != null) {
			this.playlist = _root.playlist;
		}
		
		if (_root.src != null) {
			this.src = _root.src;
		}
		
		if (_root.volume != null && !isNaN(Number(_root.volume))) {
			this.volume = Number(_root.volume);
			
			if (this.volume < 0)
				this.volume = 0;
			
			if (this.volume > 100)
				this.volume = 100;
		}
		
		if (_root.balance != null && !isNaN(Number(_root.balance))) {
			this.balance = Number(_root.balance);
			
			if (this.balance < -100)
				this.balance = -100;
			
			if (this.balance > 100)
				this.balance = 100;
		}
		
		if (_root.autoload != null) {
			this.autoload = (_root.autoload == "yes") ? true : false;
		}
		
		if (_root.autostart != null) {
			this.autostart = (_root.autostart == "yes") ? true : false;
		}
		
		if (_root.repeat != null) {
			this.repeat = (_root.repeat == "yes") ? true : false;
		}
		
		if (_root.shuffle != null) {
			this.shuffle = (_root.shuffle == "yes") ? true : false;
		}
		
		if (_root.shortcuts != null) {
			this.shortcuts = (_root.shortcuts == "yes") ? true : false;
		}
		
		if (_root.groupname != null && _root.groupname != "") {
			this.groupname = _root.groupname;
		}
		
	}
	
}
