/**
 * A simple Exception.
 * 
 * @version 0.1.0
 * @author  Marc Reichelt
 */
class net.sf.flashlib.lang.Exception {
	
	/**
	 * Message of this Exception.
	 */
	private var message : String;
	
	
	
	/**
	 * Creates a new Exception.
	 * 
	 * @param  message  Message of this Exception.
	 */
	public function Exception(message : String) {
		this.message = (message == null) ? "" : message;
	}
	
	
	
	/**
	 * Returns the name of this exception.
	 * 
	 * @return  Name of this exception.
	 */
	public function getName() : String {
		return "Exception";
	}
	
	/**
	 * Returns the message of this exception.
	 * 
	 * @return  Message of this exception.
	 */
	public function getMessage() : String {
		return this.message;
	}
	
	/**
	 * Returns a String representation of this Exception.
	 * 
	 * @return  String representation of this Exception. The String consists of the
	 *           return value of getName() plus the seperator ": " plus the return
	 *           value of getMessage().
	 */
	public function toString() : String {
		return this.getName() + ": " + this.getMessage();
	}
	
}
