import net.sf.flashlib.lang.Exception;

/**
 * Thrown when an application attempts to use null in a case where an object is required.
 * 
 * @version 0.1.0
 * @author  Marc Reichelt
 */
class net.sf.flashlib.lang.NullPointerException extends Exception {
	
	/**
	 * Creates a new NullPointerException.
	 * 
	 * @param  message  The message. If no message is given, the message is "".
	 */
	public function NullPointerException(message : String) {
		super(
			(message == null)
			? ""
			: message
		);
	}
	
	
	
	/**
	 * Returns the name of this exception.
	 * 
	 * @return  Name of this exception.
	 * @see     net.sf.flashlib.lang.Exception#getName()
	 */
	public function getName() : String {
		return "NullPointerException";
	}
	
}
