import net.sf.flashlib.lang.Exception;

/**
 * Signals that an error occurred while attempting to connect a socket to a remote address and port.<br>
 * For example, there might be no service listening at the specified address and port.
 * 
 * @version 0.1.0
 * @author  Marc Reichelt
 */
class net.sf.flashlib.net.ConnectException extends Exception {
	
	/**
	 * Creates a new ConnectException.
	 * 
	 * @param  message  The message. If no message is given, the message is "".
	 */
	public function ConnectException(message : String) {
		super(message);
	}
	
	
	
	/**
	 * Returns the name of this exception.
	 * 
	 * @return  Name of this exception.
	 * @see     net.sf.flashlib.lang.Exception#getName()
	 */
	public function getName() : String {
		return "ConnectException";
	}
	
}
