/**
 * Class to set a specific scope to a method.
 * 
 * @version 0.1.0
 * @author  Marc Reichelt
 */
class net.sf.flashlib.util.Delegate {
	
	/**
	 * Sets a given scope to a given method.
	 * 
	 * @param   scope   The scope.
	 * @param   method  The method to apply the scope to.
	 * @return  The same method as given by parameter 'method', but with the scope 'scope'.
	 */
	public static function create(scope : Object, method : Function) : Function {
		return function () {
			method.apply(scope, arguments);
		}
	}
	
}
