import net.sf.flashlib.util.logging.Logger;
import net.sf.flashlib.util.logging.LogMessage;

/**
 * A dummy logger that doesn't log anything.
 * 
 * @version 0.1.1
 * @author  Marc Reichelt
 */
class net.sf.flashlib.util.logging.DummyLogger extends Logger {
	
	/**
	 * Do not log the specified log message.
	 * 
	 * @param  message  The message that will not be logged.
	 * @see    net.sf.flashlib.util.logging.Logger#log()
	 */
	public function log(message : LogMessage) : Void {
		// this logger simply does not log anything
	}
	
	/**
	 * Don't log a message indicating a serious failure.
	 * 
	 * @param  message  The message.
	 * @see    net.sf.flashlib.util.logging.Logger#severe()
	 */
	public function severe(message : String) : Void {
		// this logger simply does not log anything
	}
	
	/**
	 * Don't log a message indicating a potential problem.
	 * 
	 * @param  message  The message.
	 * @see    net.sf.flashlib.util.logging.Logger#warning()
	 */
	public function warning(message : String) : Void {
		// this logger simply does not log anything
	}
	
	/**
	 * Don't log an informational message.
	 * 
	 * @param  message  The message.
	 * @see    net.sf.flashlib.util.logging.Logger#info()
	 */
	public function info(message : String) : Void {
		// this logger simply does not log anything
	}
	
	/**
	 * Don't log a message indicating a static configuration.
	 * 
	 * @param  message  The message.
	 * @see    net.sf.flashlib.util.logging.Logger#config()
	 */
	public function config(message : String) : Void {
		// this logger simply does not log anything
	}
	
	/**
	 * Don't log a message indicating things like minor (recoverable) failures.
	 * 
	 * @param  message  The message.
	 * @see    net.sf.flashlib.util.logging.Logger#fine()
	 */
	public function fine(message : String) : Void {
		// this logger simply does not log anything
	}
	
	/**
	 * Don't log a fairly detailed tracing message.
	 * 
	 * @param  message  The message.
	 * @see    net.sf.flashlib.util.logging.Logger#finer()
	 */
	public function finer(message : String) : Void {
		// this logger simply does not log anything
	}
	
	/**
	 * Don't log a highly detailed tracing message.
	 * 
	 * @param  message  The message.
	 * @see    net.sf.flashlib.util.logging.Logger#finest()
	 */
	public function finest(message : String) : Void {
		// this logger simply does not log anything
	}
}
